//  Nazrat Durand, 1998 07 15
#declare Detail_level=1
#include "ll_commn.inc"
#include "ll_brick.inc"
#include "Angle.inc"
#include "Glass.inc"
#include "Metals.inc"

#declare aclock = clock * 360

#declare YZ_Mirror = transform {
    matrix < -1, 0, 0,
             0, 1, 0,
             0, 0, 1,
             0, 0, 0 >
    }

#declare Move_Tower = transform {
  rotate < 0, 60, 0 >
  translate < -widr*2, 0, 0 >
  rotate < 0, -30, 0 >
  translate < -widr*15, 0, 0 >
  rotate < 0, -30, 0 >
  translate < -widr*2, 0, 0 >
  rotate < 0, 60, 0 >
  }

#declare Colour1 =  texture {
  pigment { rgb < 1, 0, 0 > }
  finish { ambient 1 }
  }
#declare Colour2 =  texture {
  pigment { rgb < 0, 1, 0 > }
  finish { ambient 1 }
  }
#declare Colour3 =  texture {
  pigment { rgb < 0, 0, 1 > }
  finish { ambient 1 }
  }
#declare Colour4 =  texture {
  pigment { rgb < 1, 1, 1 > }
  finish { ambient 1 }
  }

#declare Colour5 = texture {
  pigment { rgb < 1, 1, 0 > }
  finish { ambient 1 }
  }
#declare Colour6 = texture {
  pigment { rgb < 1, 0, 1 > }
  finish { ambient 1 }
  }
#declare Colour7 = texture {
  pigment { rgb < 0, 1, 1 > }
  finish { ambient 1 }
  }
#declare Colour8 = texture {
  pigment { rgb < 0.3, 0.3, 0.3  > }
  finish { ambient 1 }
  }
#declare Colour9 = texture {
  pigment { rgb < 0, 0, 1 > }
  finish { ambient 1 }
  }
#declare this_frame = 40
#include "Gate.inc"
#include "Tower.inc"
// #declare this_frame = aclock
#include "Curtain.inc"

///////////////////////////////////////////////////////////////////////

#declare Castle = union {

///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// Front Wall and Gate



//#declare this_frame = clock       // 40 frames to build left gate
#declare this_frame = 40
#include "Gate.inc"

/*
#if ( aclock <= 40 )                 // first 40 frames of 360 circle
  #declare this_frame = aclock
#else
  #declare this_frame = 40
#end

#if ( aclock > 90 )             // facing away from this
  #if ( aclock < 300 )
    #declare this_frame = 0
  #end
#end

#include "Gate.inc"
*/
object { Gate_Tower }                               // left gate

object { Middle_Connectors }

// #declare this_frame = aclock       // 40 frames to build right gate
// #include "Gate.inc"
/*
#if ( aclock > 320 )                // last 40 frames of 360 circle
  #declare this_frame = aclock - 320
#else
  #declare this_frame = 0
#end

#include "Gate.inc"
*/
object { Gate_Tower                                 // right gate
  transform YZ_Mirror
  translate < widr*16, 0, 0 >
  }

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

/*
#include "portcull.inc"
object { Portcullis
  translate < widr*0, talr*0, widr*2>
  }
*/

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////// Left Front Tower and Wall
                                    // comment out for frames 1-80

#declare this_frame = 40  // used for left tower animation
#include "Tower.inc"
#include "Curtain.inc"
/*
#if ( aclock > 40 )                // frames 41 to 70
  #if ( aclock <=70 )
    #declare this_frame = aclock - 40
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 100 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end
#include "Tower.inc"

#if ( aclock > 70 )                // frames 71 to 90
  #if ( aclock <= 90 )
    #declare this_frame = aclock - 70
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 170 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end

#include "Curtain.inc"
*/
union {
  object { Tower
    rotate < 0, -60, 0 >
    translate < 0, 0, widr*2 >
    rotate < 0, 30, 0 >
    }
                                   // comment out when building tower
  object { The_Wall
    translate < -widr*92, 0, -widr*8 >
    }

  transform Move_Tower
  translate < -widr*38, 0, widr*8 >
  }


////////////////////////////////////// End of Left Front Tower and Wall
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////// Right Front Tower and RF Wall


#declare this_frame = 40
#include "Tower.inc"
#include "Curtain.inc"

/*
#if ( aclock > 290 )                // frames 291 to 320
  #if ( aclock <= 320 )
    #declare this_frame = aclock - 290
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#include "Tower.inc"

#if ( aclock > 270 )                // frames 271 to 290
  #if ( aclock <= 290 )
    #declare this_frame = aclock - 270
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#include "Curtain.inc"
*/

union {
  object { Tower
    rotate < 0, -60, 0 >
    translate < 0, 0, widr*2 >
    rotate < 0, 30, 0 >
    }
  object { The_Wall
    translate < -widr*92, 0, -widr*8 >
    }

  transform Move_Tower
  translate < -widr*38, 0, widr*8 >


  transform YZ_Mirror
  translate < widr*16, 0, 0 >
  }


///////////////////////////////////// End Right Front Tower and RF Wall
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////// Left Tower and Left Rear Wall


#declare this_frame = 40
#include "Tower.inc"
#include "Curtain.inc"

/*
#if ( aclock > 90 )                // frames 91 to 120
  #if ( aclock <= 120 )
    #declare this_frame = aclock - 90
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 190 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end
#include "Tower.inc"

#if ( aclock > 120 )                // frames 121 to 140
  #if ( aclock <= 140 )
    #declare this_frame = aclock - 120
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 240 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end
#include "Curtain.inc"
*/

union {
  object { Tower
    rotate < 0, -60, 0 >
    translate < 0, 0, widr*2 >
    rotate < 0, 30, 0 >
    }

  object { The_Wall
    translate < -widr*92, 0, -widr*8 >
    }

  transform Move_Tower
  translate < -widr*92, 0, 0 >  //attach to end of LF wall

  transform Move_Tower
  translate < -widr*38, 0, widr*8 >  // swing around with LF wall
  }


//////////////////////////////////////// End of Left Tower and  LR Wall
///////////////////////////////////////////////////////////////////////
/////////////////////////////////////// Right Tower and Right Rear Wall

/*
#if ( aclock > 240 )                // frames 241 to 270
  #if ( aclock <= 270 )
    #declare this_frame = aclock - 240
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 330 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end
#include "Tower.inc"

#if ( aclock > 220 )                // frames 221 to 240
  #if ( aclock <= 240 )
    #declare this_frame = aclock - 220
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 320 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end
#include "Curtain.inc"
*/


union {
  object { Tower
    rotate < 0, -60, 0 >
    translate < 0, 0, widr*2 >
    rotate < 0, 30, 0 >
    }
  object { The_Wall
    translate < -widr*92, 0, -widr*8 >
    }

  transform Move_Tower
  translate < -widr*92, 0, 0 >  //attach to end of LF wall

  transform Move_Tower
  translate < -widr*38, 0, widr*8 >  // swing around with LF wall

  transform YZ_Mirror
  translate < widr*16, 0, 0 >
  }

//////////////////////////////////////// End of Right Tower and RR Wall
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////// Left Rear Tower
///////////////////////////////////////////////////////// and back wall

/*
#if ( aclock > 140 )                // frames 141 to 170
  #if ( aclock <= 170 )
    #declare this_frame = aclock - 140
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 240 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end
#include "Tower.inc"

#if ( aclock > 170 )                // frames 171 to 190
  #if ( aclock <= 190 )
    #declare this_frame = aclock - 170
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 270 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end
#include "Curtain.inc"
*/

union {
  object { Tower
    rotate < 0, -60, 0 >
    translate < 0, 0, widr*2 >
    rotate < 0, 30, 0 >
    }

  object { The_Wall
    translate < -widr*92, 0, -widr*8 >
    }

  transform Move_Tower
  translate < -widr*92, 0, 0 >  //attach to end of LF wall

  transform Move_Tower
  translate < -widr*92, 0, 0 >  // swing around with LF wall

  transform Move_Tower
  translate < -widr*38, 0, widr*8 >  // swing around with LF wall
  }

//////////////////////////////////////////////// End of Left Rear Tower
///////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////// Right Rear Tower
/*
#if ( aclock > 190 )                // frames 191 to 220
  #if ( aclock <= 220 )
    #declare this_frame = aclock - 190
  #else
    #declare this_frame = 40
  #end
#else
  #declare this_frame = 0
#end
#if ( aclock > 290 )            // facing away from this
  #if ( aclock < 361 )
    #declare this_frame = 0
  #end
#end
#include "Tower.inc"
*/

union {
  object { Tower
    rotate < 0, -60, 0 >
    translate < 0, 0, widr*2 >
    rotate < 0, 30, 0 >
    }

  transform Move_Tower
  translate < -widr*92, 0, 0 >  //attach to end of LF wall

  transform Move_Tower
  translate < -widr*92, 0, 0 >  // swing around with LF wall

  transform Move_Tower
  translate < -widr*38, 0, widr*8 >  // swing around with LF wall

  transform YZ_Mirror
  translate < widr*16, 0, 0 >
  }


////////////////////////////////////////////////// End Right Rear Tower
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////// Back Wall




///////////////////////////////////////////////////////// End Back Wall
///////////////////////////////////////////////////////////////////////

}

///////////////////////////////////////////////////////// END OF CASTLE
///////////////////////////////////////////////////////////////////////
