#declare Detail_level=1        // = 2 for showing brick studs
#include "ll_commn.inc"
#include "ll_brick.inc"

// House built by Nazrat Durand 1998 07 06
// this takes  bricks (2x4) = 76
//                    (2x3) = 38
//                    (2x2) = 32
// for a total of 146 bricks

#declare Colour1 =  texture {
  pigment { rgb < 1, 0, 0 > }
  finish { ambient 1 }
  }
#declare Colour2 =  texture {
  pigment { rgb < 0, 1, 0 > }
  finish { ambient 1 }
  }
#declare Colour3 =  texture {
  pigment { rgb < 0, 0, 1 > }
  finish { ambient 1 }
  }
#declare Colour4 =  texture {
  pigment { rgb < 1, 1, 1 > }
  finish { ambient 1 }
  }

#declare Colour5 = texture {
  pigment { rgb < 1, 1, 0 > }
  finish { ambient 1 }
  }
#declare Colour6 = texture {
  pigment { rgb < 1, 0, 1 > }
  finish { ambient 1 }
  }
#declare Colour7 = texture {
  pigment { rgb < 0, 1, 1 > }
  finish { ambient 1 }
  }
#declare Colour8 = texture {
  pigment { rgb < 0.3, 0.3, 0.3  > }
  finish { ambient 1 }
  }
#declare Colour9 = texture {
  pigment { rgb < 0, 0, 1 > }
  finish { ambient 1 }
  }

///////////////////////////////////////////////////////////////////////

#declare Front_door_and_frame = union {

  #if ( this_frame >= 1 )
    object { tall2x4
      translate < -widr*2, 0, -widr*6 >
      texture { Colour4}
      }
    #end
  #if ( this_frame >= 2 )
    object { tall2x4
      translate < -widr*2, talr*1, -widr*6 >
      texture { Colour4}
      }
    object { tall2x2
      translate < -widr*4, talr*1, -widr*6 >
      texture { Colour1}
      }
    object { tall2x2
      translate < widr*2, talr*1, -widr*6 >
      texture { Colour1}
      }
    #end
  #if ( this_frame >= 3 )
    object { tall2x4
      translate < -widr*2, talr*2, -widr*6 >
      texture { Colour4}
      }
    #end
  #if ( this_frame >= 4 )
    object { tall2x4
      translate < -widr*2, talr*3, -widr*6 >
      texture { Colour4}
      }
    object { tall2x2
      translate < -widr*4, talr*3, -widr*6 >
      texture { Colour1}
      }
    object { tall2x2
      translate < widr*2, talr*3, -widr*6 >
      texture { Colour1}
      }
    #end
  #if ( this_frame >= 5 )
    object { tall2x4
      translate < -widr*2, talr*4, -widr*6 >
      texture { Colour4}
      }
    #end
  #if ( this_frame >= 6 )
    object { tall2x4
      translate < -widr*4, talr*5, -widr*6 >
      texture { Colour1}
      }
    object { tall2x4
      translate < -widr*0, talr*5, -widr*6 >
      texture { Colour1}
      }
    #end
  }

///////////////////////////////////////////////////////////////////////

#declare House_level_1 = union {

  object { tall2x4
    translate < -widr*6, 0, -widr*6 >
    texture { Colour1}
    }
  object { tall2x4
    translate < widr*2, 0, -widr*6 >
    texture { Colour1}
    }
  object { tall2x4
    translate < -widr*4, 0, widr*4 >
    texture { Colour1}
    }
  object { tall2x4
    translate < widr*0, 0, widr*4 >
    texture { Colour1}
    }
  object { tall2x4
    rotate < 0, 90, 0 >
    translate < -widr*6, 0, widr*6 >
    texture { Colour1}
    }
  object { tall2x4
    rotate < 0, 90, 0 >
    translate < widr*4, 0, widr*6 >
    texture { Colour1}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < -widr*6, 0, widr*2 >
    texture { Colour1}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < -widr*6, 0, -widr*1 >
    texture { Colour1}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < widr*4, 0, widr*2 >
    texture { Colour1}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < widr*4, 0, -widr*1 >
    texture { Colour1}
    }

  }
///////////////////////////////////////////////////////////////////////
#declare House_level_2 = union {

  object { tall2x4
    translate < -widr*6, 0, widr*4 >
    texture { Colour1}
    }
  object { tall2x4
    translate < -widr*2, 0, widr*4 >
    texture { Colour1}
    }
  object { tall2x4
    translate < widr*2, 0, widr*4 >
    texture { Colour1}
    }
  object { tall2x4
    rotate < 0, 90, 0 >
    translate < -widr*6, 0, widr*1 >
    texture { Colour1}
    }
  object { tall2x4
    rotate < 0, 90, 0 >
    translate < widr*4, 0, widr*1 >
    texture { Colour1}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < -widr*6, 0, -widr*3 >
    texture { Colour1}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < -widr*6, 0, widr*4 >
    texture { Colour1}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < widr*4, 0, -widr*3 >
    texture { Colour1}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < widr*4, 0, widr*4 >
    texture { Colour1}
    }

  }
///////////////////////////////////////////////////////////////////////

#declare Attic_wall = union {

  #if ( this_frame >= 7 )
    object { tall2x4
      translate < -widr*5, talr*6, 0 >
      texture { Colour1}
      }
    object { tall2x2
      translate < -widr*1, talr*6, 0 >
      texture { Colour1}
      }
    object { tall2x4
      translate < widr*1, talr*6, 0 >
      texture { Colour1}
      }
    #end
  #if ( this_frame >= 8 )
    object { tall2x4
      translate < -widr*4, talr*7, 0 >
      texture { Colour1}
      }
    object { tall2x4
      translate < widr*0, talr*7, 0 >
      texture { Colour1}
      }
    #end
  #if ( this_frame >= 9 )
    object { tall2x2
      translate < -widr*3, talr*8, 0 >
      texture { Colour1}
      }
    object { tall2x2
      translate < -widr*1, talr*8, 0 >
      texture { Colour1}
      }
    object { tall2x2
      translate < widr*1, talr*8, 0 >
      texture { Colour1}
      }
    #end
  #if ( this_frame >= 10 )
    object { tall2x4
      translate < -widr*2, talr*9, 0 >
      texture { Colour1}
      }
    #end
  #if ( this_frame >= 11 )
    object { tall2x2
      translate < -widr*1, talr*10, 0 >
      texture { Colour1}
      }
    #end
  }

///////////////////////////////////////////////////////////////////////
#declare Roof_beam_1 = union {
  object { tall2x4
    rotate < 0, 90, 0 >
    translate < 0, 0, -widr*3 >
    texture { Colour5}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < 0, 0, widr*0 >
    texture { Colour5}
    }
  object { tall2x3
    rotate < 0, 90, 0 >
    translate < 0, 0, widr*3 >
    texture { Colour5}
    }
  object { tall2x4
    rotate < 0, 90, 0 >
    translate < 0, 0, widr*7 >
    texture { Colour5}
    }
  }
///////////////////////////////////////////////////////////////////////
#declare Roof_beam_2 = union {
  object { tall2x2
    translate < 0, 0, -widr*7 >
    texture { Colour5}
    }
  object { tall2x4
    rotate < 0, 90, 0 >
    translate < 0, 0, -widr*1 >
    texture { Colour5}
    }
  object { tall2x2
    translate < 0, 0, -widr*1 >
    texture { Colour5}
    }
  object { tall2x4
    rotate < 0, 90, 0 >
    translate < 0, 0, widr*5 >
    texture { Colour5}
    }
  object { tall2x2
    translate < 0, 0, widr*5 >
    texture { Colour5}
    }
  }

///////////////////////////////////////////////////////////////////////

#declare House = union {
  object { Front_door_and_frame
    }
  #if ( this_frame >= 1 )
    object { House_level_1
      translate < 0, talr*0, 0 >
      }
    #end
  #if ( this_frame >= 2 )
    object { House_level_2
      translate < 0, talr*1, 0 >
      }
    #end
  #if ( this_frame >= 3 )
    object { House_level_1
      translate < 0, talr*2, 0 >
      }
    #end
  #if ( this_frame >= 4 )
    object { House_level_2
      translate < 0, talr*3, 0 >
      }
    #end
  #if ( this_frame >= 5 )
    object { House_level_1
      translate < 0, talr*4, 0 >
      }
    #end
  #if ( this_frame >= 6 )
    object { House_level_2
      translate < 0, talr*5, 0 >
      }
    #end

  object { Attic_wall
    translate < 0, 0, -widr*6 >
    }
  object { Attic_wall
    translate < 0, 0, widr*4 >
    }

  #if ( this_frame >= 7 )
    object { Roof_beam_1
      translate < widr*5, talr*6, 0 >
      }
    object { Roof_beam_1
      translate < -widr*7, talr*6, 0 >
      }
    #end

  #if ( this_frame >= 8 )
    object { Roof_beam_2
      translate < widr*4, talr*7, 0 >
      }
    object { Roof_beam_2
      translate < -widr*6, talr*7, 0 >
      }
    #end

  #if ( this_frame >= 9 )
    object { Roof_beam_1
      translate < widr*3, talr*8, 0 >
      }
    object { Roof_beam_1
      translate < -widr*5, talr*8, 0 >
      }
    #end

  #if ( this_frame >= 10 )
    object { Roof_beam_2
      translate < widr*2, talr*9, 0 >
      }
    object { Roof_beam_2
      translate < -widr*4, talr*9, 0 >
      }
    #end

  #if ( this_frame >= 11 )
    object { Roof_beam_1
      translate < widr*1, talr*10, 0 >
      }
    object { Roof_beam_1
      translate < -widr*3, talr*10, 0 >
      }
    #end

  #if ( this_frame >= 12 )
    object { Roof_beam_2
      translate < widr*0, talr*11, 0 >
      }
    object { Roof_beam_2
      translate < -widr*2, talr*11, 0 >
      }
    #end

  #if ( this_frame >= 13 )
    object { Roof_beam_1
      translate < -widr*1, talr*12, 0 >
      }
    #end
  }



////////////////////////////////////////////////////////// END OF HOUSE
///////////////////////////////////////////////////////////////////////
